# -*- coding: utf-8 -*-
"""pipeline_transaction_classification.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1CtVybR_wflvkaiwOaozaBOxskavAriqf

# Transaction Classification

Using NLTK and Scikit-Learn to classify payments

make sure all dependencies are installed
"""

# Commented out IPython magic to ensure Python compatibility.
# % pip install nltk
# % pip install -U scikit-learn

"""import all needed libraries 


> **nlkt**   : for machine learning model  
> **sklearn**: for machine learning model  
> **pandas** : for loading the data


"""

import nltk
import random
import pandas as pd
from sklearn.pipeline import Pipeline
from sklearn.feature_extraction.text import CountVectorizer
from sklearn.feature_extraction.text import TfidfTransformer
from sklearn.linear_model import SGDClassifier
from sklearn.naive_bayes import MultinomialNB

"""## Load dataset"""

all_transactions = pd.read_csv('all_data_new.csv') # load dataset
percent = int(len(all_transactions)*.999)
train_set = all_transactions[:percent]
test_set  = all_transactions[percent:]
final_test_data = pd.read_csv('temp_now.csv')

"""## NLTK Classification

Helping functions
"""

def _remove_unwanted_words(words):
    '''remove words has numbers or less than 2 char length'''
    new_words = list()
    for word in words:
        if not _has_number(word) and len(word)>1:
            new_words.append(word)
    return new_words

def _has_number(input_string):
    '''check if text has number in'''
    return any(char.isdigit() for char in input_string)

def transaction_features(description): # the main function
    '''extract features from transaction '''
    description = description.replace('\\',' ').replace('BNK',' ')
    words = description.split()
    new_words = _remove_unwanted_words(words)
    features = dict()
    x = 1
    for word in new_words:
      features[f"{x}'main"] = word
      x+=1
    return features

rows = all_transactions.shape[0]
data = list()
for row in range(rows):
  data.append((all_transactions['description'].iloc[row],
               all_transactions['categorie'].iloc[row])) # return a tuble with description and categorie

featuresets = [(transaction_features(d),c) for d,c in data ]

nltk_train_set, nltk_test_set = featuresets[:percent], featuresets[percent:] # split dataset to train and test 
classifier = nltk.NaiveBayesClassifier.train(nltk_train_set) # classify using NaiveBayes classification (train the model)
print(nltk.classify.accuracy(classifier, nltk_test_set)) # print the accuracy

classifier.labels() # print categories (labels)

"""### Test Classification """

test_transaction = 'POS PURCHASE FT20154K5LZ8\BNKTOTAL BONJOUR 114702 MATROUH 17AEG00057298 5264390000001425'
processed_test_transaction = transaction_features(test_transaction)

classifier.classify(processed_test_transaction)# to test one transaction

"""### NLTK Classifier API"""

def nltk_classify(transactions:list) -> list:
    '''return labels and confidance score '''
    labels = list()
    for transaction in transactions:
      processed_trans = transaction_features(transaction)
      label_prob = classifier.prob_classify(processed_trans)
      # label = classifier.classify(processed_trans)
      label = label_prob.max()
      prob = label_prob.prob(label)
      labels.append((label,prob))
    return labels

"""## Scikit-Learn Classification

Helping function
"""

def scikit_transaction_features(description):
    description = description.replace('\\',' ').replace('BNK',' ')
    words = description.split()
    new_words = _remove_unwanted_words(words)
    
    return " ".join(new_words)

"""### Cleaning Data"""

train_set['description'] = train_set['description'].apply(scikit_transaction_features)
test_set ['description'] = test_set ['description'].apply(scikit_transaction_features)

"""### PipeLine
1. using `BOW (Bags of words)` for feature extraction
2. using ` tf–idf (Term Frequency times Inverse Document Frequency)` downscale weights for words that occur in many transactions
3. using two Classifiers :  
    - naïve Bayes classifier "multinomial variant"
    -  support vector machine (SVM) (slower)
  

"""

####################SVM Classifier Pipeline#####################################
SGD_clf = Pipeline([
    ('vect', CountVectorizer()),
    ('tfidf', TfidfTransformer()),
    ('clf', SGDClassifier(loss='log', penalty='l2', alpha=1e-3, random_state=42, max_iter=5, tol=None))])
##################Naive Bayes Classifier Pipeline###############################
MN_clf = Pipeline([
    ('vect', CountVectorizer()),
    ('tfidf', TfidfTransformer()),
    ('clf', MultinomialNB())
])
#######################Train the models#########################################
_ = SGD_clf.fit(train_set['description'], train_set['categorie'])
_ = MN_clf.fit(train_set['description'], train_set['categorie'])

print(SGD_clf.score(test_set['description'], test_set['categorie']))
print(MN_clf.score(test_set['description'], test_set['categorie']))

print(nltk_classify([test_set['description'].iloc[0]]))

"""### Test Classification"""

S_test_transaction = 'POS PURCHASE FT20154K5LZ8\BNKTOTAL BONJOUR 114702 MATROUH 17AEG00057298 5264390000001425'
S_processed_test_transaction = scikit_transaction_features(S_test_transaction)

print(SGD_clf.predict([S_processed_test_transaction]))
print(MN_clf.predict([S_processed_test_transaction]))

"""### Scikit-Learn Classifier API"""

def Scikit_learn_SGD_classify(transactions:list)-> list: 
    '''return labels and confidance score '''
    labels = list()
    processed_trans = [scikit_transaction_features(transaction) for transaction in transactions]
    
    SGD_clf_prediction      = SGD_clf.predict(processed_trans)
    SGD_clf_prediction_prob = [p.max() for p in SGD_clf.predict_proba(processed_trans)]
    labels = [(label,probability) for label,probability in zip(SGD_clf_prediction,SGD_clf_prediction_prob)]
    return labels

def Scikit_learn_NP_classify(transactions:list)-> list: 
    '''return labels and confidance score '''
    labels = list()
    processed_trans = [scikit_transaction_features(transaction) for transaction in transactions]
    
    MN_clf_prediction       = MN_clf.predict (processed_trans)
    MN_clf_prediction_prob  = [p.max() for p in MN_clf.predict_proba(processed_trans)]
    labels = [(label,probability) for label,probability in zip(MN_clf_prediction,MN_clf_prediction_prob)]
    return labels

"""## Test All classifiers"""

test_str = final_test_data['description'].iloc[15:20]
print(test_str)
print(f'NLTK Classification: {nltk_classify(test_str)}')
print(f'SVM-SGD Classification: {Scikit_learn_SGD_classify(test_str)}')
print(f'Naive Bayes Classification: {Scikit_learn_NP_classify(test_str)}')

"""# Research and Development R&D"""

DecisionTree_classifier = nltk.classify.DecisionTreeClassifier.train(nltk_train_set)

DecisionTree_classifier.classify(processed_test_transaction)

print(nltk.classify.accuracy(DecisionTree_classifier, nltk_test_set))

from sklearn.svm import SVC
from nltk.classify import SklearnClassifier
from sklearn.naive_bayes import BernoulliNB

Bernoulli_classify = SklearnClassifier(BernoulliNB()).train(nltk_train_set)
SVC_classify = SklearnClassifier(SVC(probability=True), sparse=False).train(nltk_train_set)

print(nltk.classify.accuracy(Bernoulli_classify, nltk_test_set))
print(nltk.classify.accuracy(SVC_classify, nltk_test_set))

test_transaction = 'POS PURCHASE FT21131T74F0\BNK ELMENIAWY CAIRO S 07BEG 234065025264390000000658'
processed_test_transaction = transaction_features(test_transaction)
print(DecisionTree_classifier.classify(processed_test_transaction))
print(Bernoulli_classify.classify(processed_test_transaction))
print(SVC_classify.classify(processed_test_transaction))
print(nltk_classify([test_transaction]))
print(Scikit_learn_SGD_classify([test_transaction]))
print(Scikit_learn_NP_classify([test_transaction]))

label_prob = SVC_classify.prob_classify(processed_test_transaction)
label = label_prob.max()
prob = label_prob.prob(label)
print(label,' ',prob)

import pickle

pickle.dump(classifier, open('nltk_classifier.sav', 'wb'))
pickle.dump(SGD_clf,    open('SGD_classifier.sav', 'wb'))
pickle.dump(MN_clf,     open('MN_classifier.sav', 'wb'))

loaded_model = pickle.load(open('nltk_classifier.sav', 'rb'))
loaded_model.classify(processed_test_transaction)

processed_test_transaction